<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from dependence.texi on 28 April 1999 -->

<TITLE>The DEPENDENCE Library - Example</TITLE>
<link href="dependence_3.html" rel=Next>
<link href="dependence_1.html" rel=Previous>
<link href="dependence_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="dependence_1.html">first</A>, <A HREF="dependence_1.html">previous</A>, <A HREF="dependence_3.html">next</A>, <A HREF="dependence_3.html">last</A> section, <A HREF="dependence_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC2" HREF="dependence_toc.html#TOC2">An Example</A></H1>

<P>
An example of using the dependence analyzer is given at the end of this
section.  Most of the code deals with finding array accesses in a
program in SUIF.  To use the dependence analyzer, there are two
main points to which readers should pay additional attention.  First,
before <CODE>DependenceTest</CODE> can be called for array accesses in a given
procedure, <CODE>fill_in_access</CODE> must be called to annotate the code
with information needed by the dependence analyzer.  In our code below,
note that method <CODE>do_proc</CODE> calls <CODE>fill_in_access</CODE> before
processing each procedure body.  Given two array accesses, method
<CODE>print_dep</CODE> demonstrates the simplicity of testing for dependence
between two array accesses.  <CODE>print_dep</CODE> first tests whether the
accesses are data dependent by calling <CODE>DependenceTest</CODE>, then the
result of the test is output to stdout using the <CODE>print</CODE> method
of class <CODE>dvlist</CODE>.  Lastly, note the files <CODE>stdlib.h</CODE>,
<CODE>suif.h</CODE>, <CODE>useful.h</CODE> and <CODE>dependence.h</CODE> must be included.

</P>

<PRE>
#include "suif.h"
#include "useful.h"
#include "dependence.h"
#include &#60;stdlib.h&#62;

/***************************************************************************
 * Declare a new class which is a list of "in_array"'s                     *
 ***************************************************************************/
DECLARE_DLIST_CLASS(array_instr_list, in_array *);

void find_array_instr(tree_node_list * tnl, array_instr_list * ail);
void find_array_instr(tree_node * tn, array_instr_list * ail);
void find_array_instr(instruction * i, array_instr_list * ail);

/***************************************************************************
 * 
 ***************************************************************************/
void print_dep(in_array * ai1, in_array * ai2)
{
    dvlist * dep = DependenceTest(ai1, ai2);
    assert(dep);
    if(!dep-&#62;indep()) 
        dep-&#62;print(stdout);
}

/***************************************************************************
 *
 ***************************************************************************/
void process_array_instr_list(array_instr_list * ail) 
{
    array_instr_list_iter iter1(ail);
    while(!iter1.is_empty()) {
        in_array * ai1 = iter1.step();
        if(is_lhs(ai1)) {
            var_sym * vs1 = get_sym_of_array(ai1);
            print_array_access(ai1);
            printf("Output\n");
            print_dep(ai1, ai1);

            printf("True/anti\n");
            array_instr_list_iter iter2(ail);
            while(!iter2.is_empty()) {
                in_array * ai2 = iter2.step();
                var_sym * vs2 = get_sym_of_array(ai2);
                if(vs1 == vs2)
                    if(!is_lhs(ai2))
                        print_dep(ai1, ai2);
            }
        }
    }

    
}

/***************************************************************************
 * The main iterator over structured control-flow.                         *
 * When there is no outer for loop ail will be NULL.  ail will be assigned *
 * at the outermost for loops. All the array accesses are collected and    *
 * print routine is called at the outermost for loop.                      *
 ***************************************************************************/
void find_array_instr(tree_node_list * tnl, array_instr_list * ail)
{
    tree_node_list_iter iter(tnl);
    while(!iter.is_empty()) {
        tree_node * tn = iter.step();
        
        switch(tn-&#62;kind()) {
        case TREE_FOR:
            tree_for * tnf = (tree_for *)tn;
            find_array_instr(tnf-&#62;lb_list(), ail);
            find_array_instr(tnf-&#62;ub_list(), ail);
            find_array_instr(tnf-&#62;step_list(), ail);
            
            boolean outermost = FALSE;
            array_instr_list * ail_bdy = ail;
            if(ail_bdy == NULL) {
                outermost = TRUE;
                ail_bdy = new array_instr_list;
            }
            printf("For loop %s %s\n", 
                   tnf-&#62;index()-&#62;name(), 
                   outermost?"(Outermost)":"");
            
            find_array_instr(tnf-&#62;landing_pad(), ail_bdy);
            find_array_instr(tnf-&#62;body(), ail_bdy);
            
            if(outermost) process_array_instr_list(ail_bdy);
            break;
            
        case TREE_IF:
            tree_if * tni = (tree_if *)tn;
            find_array_instr(tni-&#62;header(), ail);
            find_array_instr(tni-&#62;then_part(), ail);
            find_array_instr(tni-&#62;else_part(), ail);
            break;
            
        case TREE_LOOP:
            tree_loop * tnl = (tree_loop *)tn;
            find_array_instr(tnl-&#62;body(), ail);
            find_array_instr(tnl-&#62;test(), ail);
            break;
            
        case TREE_BLOCK:
            tree_block * tnb = (tree_block *)tn;
            find_array_instr(tnb-&#62;body(), ail);
            break;
            
        case TREE_INSTR:
            tree_instr * tnin = (tree_instr *)tn;
            if(ail)
                find_array_instr(tnin-&#62;instr(), ail);
            break;
            
        default:
            assert(0);
            break;
        }
    }
}

/***************************************************************************
 * Iterate over all the instructions of expression trees, add array        *
 * instructions to the list.                                               *
 ***************************************************************************/
void find_array_instr(instruction * ins, array_instr_list * ail)
{
    if(ins-&#62;opcode() == io_array) {
        assert(ail);
        in_array * ia = (in_array *)ins;
        ail-&#62;append(ia);
    }

    for(int i=0; i&#60;ins-&#62;num_srcs(); i++) {
        operand op(ins-&#62;src_op(i));
        if(op.is_instr())
            find_array_instr(op.instr(), ail);
    }
}

/***************************************************************************
 * create the annotations needed by dependence by calling fill_in_access   *
 * and start processing..                                                  *
 ***************************************************************************/
void do_proc(tree_proc * tp)
{
    proc_sym * psym = tp-&#62;proc();
    printf("=======%s======= \n", psym-&#62;name());
    fill_in_access(tp);
    find_array_instr(tp-&#62;body(), NULL);
}

/***************************************************************************
 * Initialize and iterate over all the procedures.                         *
 ***************************************************************************/
main(int argc, char * argv[])
{
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc);
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="dependence_1.html">first</A>, <A HREF="dependence_1.html">previous</A>, <A HREF="dependence_3.html">next</A>, <A HREF="dependence_3.html">last</A> section, <A HREF="dependence_toc.html">table of contents</A>.
</BODY>
</HTML>
